-- SCRIPT DO BANCO DE DADOS "ActiveDelphi"
-- Autor: Ryan Bruno C Padilha (ryan.padilha@gmail.com)
-- Revista Active Delhi: Orientao a Objetos no Delphi - Srie de 3 artigos.

-- EMPRESA
CREATE TABLE EMPRESA(
  EMP_CODIGO		SERIAL NOT NULL,
  EMP_RAZAO		VARCHAR(50),
  EMP_FANTASIA		VARCHAR(50),
  EMP_DT_CADASTRO	DATE,
  EMP_DT_ABERTURA	DATE,
  EMP_STATUS		INTEGER,
  EMP_ALIAS		VARCHAR(50),
  EMP_TELEFONE		VARCHAR(14),
  EMP_FONEFAX		VARCHAR(14),
  EMP_CNPJ		VARCHAR(20),
  EMP_IE		VARCHAR(20),
  EMP_IEST		VARCHAR(20),
  EMP_IM		VARCHAR(20),
  EMP_CRT		INTEGER,
  EMP_CNAE		VARCHAR(10),
  EMP_EMAIL		VARCHAR(50),
  EMP_PAGINA		VARCHAR(50),
  EMP_CONTATO		VARCHAR(50),
  EMP_MENSAGEM		TEXT
);
ALTER TABLE EMPRESA ADD CONSTRAINT PK_EMPRESA PRIMARY KEY(EMP_CODIGO);

-- ENDERECO
CREATE TABLE ENDERECO(
  END_CODIGO		SERIAL NOT NULL,
  END_LOGRADOURO	VARCHAR(100) NOT NULL,
  END_NUMERO		VARCHAR(10) NOT NULL,
  END_COMPLEMENTO	VARCHAR(50),
  END_CEP		VARCHAR(10),
  END_TIPO		INTEGER,
  END_CORRESP		BOOLEAN,
  END_PT_REFERENCIA	VARCHAR(200),
  END_BAIRRO		VARCHAR(100),
  END_CIDADE		VARCHAR(100)
);
ALTER TABLE ENDERECO ADD CONSTRAINT PK_ENDERECO PRIMARY KEY(END_CODIGO);
ALTER TABLE ENDERECO ADD COLUMN EMP_CODIGO INTEGER;
ALTER TABLE ENDERECO ADD CONSTRAINT FK_END_EMPRESA FOREIGN KEY(EMP_CODIGO) REFERENCES EMPRESA(EMP_CODIGO);
